<template>
  <v-app v-if="isMounted">
    <Loading :loading="loading" />
    <TheToolbar v-if="this.$route.name !== 'Login'" />
    <Snackbar />
    <v-main>
      <transition mode="out-in" :duration="300">
        <router-view />
      </transition>
    </v-main>
    <Alert />
  </v-app>
</template>

<script>
import Loading from './components/loading/Loading.vue'
import Alert from './components/Alert.vue'
import TheToolbar from './components/TheToolbar'
import Snackbar from './components/base/Snackbar'
import { mapMutations } from 'vuex'

export default {
  name: 'App',
  components: {
    TheToolbar,
    Snackbar,
    Loading,
    Alert,
  },
  data: () => ({
    isMounted: false,
    dialog: true,
    logged: false,
  }),
  computed: {
    loading() {
      return this.$store.state.user.loading
    },
  },

  async beforeCreate() {
    const rootEntities = await this.$getItem('rootEntities')
    const userInfo = await this.$getItem('userInfo')
    const toolbarEntities = await this.$getItem('toolbarEntities')
    rootEntities && this.UPDATE_ROOT_ENTITIES(rootEntities)
    userInfo && this.DO_LOGIN(userInfo)
    toolbarEntities && this.UPDATE_TOOLBAR_ENTITIES(toolbarEntities)
    const routedEntity = await this.$getItem('routedEntity')
    if (routedEntity) {
      const userEntityActions = routedEntity.privileges.actions
      let setMethods = new Set()
      let map = new Map(
        userEntityActions.map((action) => {
            action.methods.forEach((method) => {
              setMethods.add(method)
            })
            return [action.name, action]
          })
      )        

      this.UPDATE_SET_ACTIONS(setMethods)
      this.UPDATE_MAPPED_ACTIONS(map)
    }
    this.isMounted = true
  },

  methods: {
    ...mapMutations('user', [
      'UPDATE_ROOT_ENTITIES',
      'DO_LOGIN',
      'UPDATE_TOOLBAR_ENTITIES',
      'UPDATE_MAPPED_ACTIONS',
      'UPDATE_SET_ACTIONS',
    ]),
  },
}
</script>

<style>
@import url('https://fonts.googleapis.com/css2?family=Urbanist:wght@400;500;600;625&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Urbanist:wght@400;500;600;625&family=Varela+Round&display=swap');

* {
  -webkit-text-size-adjust: none;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  /* font-family: 'Urbanist', Oswald, Roboto, sans-serif; */
  font-family: 'Varela Round', Oswald, Roboto, sans-serif;
}

.polvoFont {
  letter-spacing: 0.4rem;
}

input:-webkit-autofill,
input:-webkit-autofill:hover,
input:-webkit-autofill:focus,
input:-webkit-autofill:active {
  -webkit-transition: 'color 9999s ease-out, background-color 9999s ease-out';
  -webkit-transition-delay: 9999s;
}

/* //router effect */
.v-enter,
.v-leave-to {
  opacity: 0;
}

.v-enter {
  transform: translate3d(0, -10px, 0);
}

.v-leave-to {
  transform: translate3d(0, 10px, 0);
}
.v-enter-active,
.v-leave-active {
  transition: all 0.3s;
}

/* scroll */
.scrollForm {
  max-width: 98%;
  max-height: 65vh !important;
  overflow-y: auto;
  padding-bottom: 0px !important;
  margin-bottom: 16px;
}
.v-messages {
  min-height: 0px !important;
}
.v-treeview-node__label {
  padding-left: 5px;
  padding-top: 3px;
}

.v-treeview-node__label:hover {
  color: #2a0845;
  font-weight: 600;
}
.v-treeview-node--leaf:hover {
  background-color: #f5f5f5;
  color: #2a0845;
  font-weight: 600;
}

.v-treeview-node:hover /deep/ .v-icon {
  color: #2a0845 !important;
}

.v-treeview-node__prepend > .v-icon:hover {
  color: #2a0845;
}

.v-treeview-node__content:hover > .v-treeview-node__prepend > .v-icon {
  color: #2a0845 !important;
}

.v-treeview-node--click:hover {
  color: #2a0845;
}

.v-data-footer__icons-before {
  margin-top: 0.5rem !important;
}

.v-data-footer__icons-after {
  margin-top: 0.5rem !important;
}

.supportIconsTable {
  padding-right: 1rem;
}

.supportIconsTable > .v-btn {
  margin-right: 2px;
}

.supportIconsTable > .v-btn:nth-last-child() {
  margin-right: 0px;
}

.supportIconsTable > .v-btn:hover {
  color: #ffc107 !important;
}

.supportIconsTable > .v-btn:before {
  background-color: transparent !important;
}
</style>
